package com.kingdee.eas.custom.compensation.handler;

import cn.com.servyou.dto.ApiResponse;
import cn.com.servyou.dto.AsyncResult;
import cn.com.servyou.dto.declare.CompanyDeclareRequest;
import cn.com.servyou.dto.tax.*;
import cn.com.servyou.rmi.client.ClientProxyFactory;
import cn.com.servyou.service.DeclarationRequest;
import com.alibaba.fastjson.JSONObject;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.dao.ormapping.ObjectUuidPK;
import com.kingdee.eas.basedata.hraux.NationalityInfo;
import com.kingdee.eas.basedata.person.PersonInfo;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.custom.shuiyou.task.TaskCatalogEnum;
import com.kingdee.eas.custom.shuiyou.uitls.ISYUtilsFacade;
import com.kingdee.eas.custom.shuiyou.uitls.SYUtilsFacadeFactory;
import com.kingdee.eas.custom.shuiyou.utils.ClientProxyFactoryUtils;
import com.kingdee.shr.base.syssetting.context.SHRContext;
import com.kingdee.shr.base.syssetting.exception.SHRWebException;
import com.kingdee.shr.base.syssetting.web.json.JSONUtils;
import com.kingdee.shr.compensation.app.tax.*;
import com.kingdee.shr.compensation.util.Base64Utils;
import com.kingdee.shr.compensation.web.handler.tax.IncomeTaxDeclareListHandler;
import com.kingdee.util.StringUtils;
import org.apache.log4j.Logger;
import org.springframework.ui.ModelMap;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.math.BigDecimal;
import java.sql.SQLException;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * @author qingwu
 * @date 2024/9/18
 * @apiNote ˰걨չ
 */
public class IncomeTaxDeclareListHandlerEx extends IncomeTaxDeclareListHandler {
    Logger logger = Logger.getLogger("com.kingdee.eas.custom.compensation.handler.IncomeTaxDeclareListHandlerEx");
    String personName = "Խ";
    String cardType = "֤";
    String cardNumber = "828888201005039412";
    /**
     * ˰걨
     *
     * @param request
     * @param response
     * @param modelMap
     */
    public void taxDeclaresAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap) throws BOSException, SHRWebException {
        logger.error("taxDeclareAction-----start-------");

        Context ctx = SHRContext.getInstance().getContext();
        //˰걨
        //String selectedId = request.getParameter("selectedId");
        //String sqlInString = CmpUtils.spiltToSqlString(selectedId);
        //if (StringUtils.isEmpty(sqlInString)) {
        //    sqlInString = "''";
        //}
        try {
            //String oqlBuffer = "select id,yearMonth,totalPerson,totalMoney,taxRebate,declareStatus,versionCode,yearMonthDate,tbType,taxUnit.id,taxUnit.name,taxUnit.taxNumber,taxUnit.regNumber,taxUnit.areaCode,taxUnit.declPassword, batchNo where id in ( " + sqlInString + " )";
            //IncomeTaxDeclarCollection declareCollection = IncomeTaxDeclarFactory.getLocalInstance(ctx).getIncomeTaxDeclarCollection(oqlBuffer);
            IncomeTaxDeclarCollection declareCollection = new IncomeTaxDeclarCollection();
            Map<String, List<Map<String, Object>>> declareDataMap = null;
            List<Map<String, Object>> list = new ArrayList<>();
            Map<String, Object> map = new HashMap<>();
            map.put("personName", personName);
            map.put("cardType", cardType);
            map.put("cardNumber",cardNumber);

            if (declareCollection.size() == 0) {
                declareCollection.add(new IncomeTaxDeclarInfo());
            }
            ApiResponse<AsyncResult> apiResponse = null;
            ObjectMapper mapper = new ObjectMapper();
            for (int i = 0; i < declareCollection.size(); i++) {
                IncomeTaxDeclarInfo incomeTaxDeclarInfo = declareCollection.get(i);
                //˰λ
                //TaxUnitInfo taxUnitInfo = incomeTaxDeclarInfo.getTaxUnit();
                TaxUnitInfo taxUnitInfo = TaxUnitFactory.getLocalInstance(ctx).getTaxUnitInfo(new ObjectUuidPK("FqEAAACXVqyPHZiq"));
                //
                //String yearMonth = incomeTaxDeclarInfo.getYearMonth();
                //
                ClientProxyFactory clientProxyFactory = ClientProxyFactoryUtils.getClientProxyFactory();
                //˰ӿ
                DeclarationRequest declarationRequest = clientProxyFactory.getDeclarationRequest();
                //ȡ
                //ȡ
                CompanyDeclareRequest declareRequestParameter = getDeclareRequestParameter(taxUnitInfo, declareDataMap, "202408");
                //걨ݱ
                apiResponse = declarationRequest.send(declareRequestParameter);
                logger.error("asyncResultApiResponse-----getCode-------" + apiResponse.getHead().getCode());
                logger.error("asyncResultApiResponse-----getMsg--------" + apiResponse.getHead().getMsg());
                if (apiResponse.getHead().getCode().equals("00000000")) {
                    AsyncResult body = apiResponse.getBody();
                    String requestId = body.getRequestId();
                    logger.error("requestId-----" + requestId);
                    logger.error("apiResponse-----" + mapper.writeValueAsString(apiResponse));
                    //ѯ㷴
                    ISYUtilsFacade isyUtilsFacade = SYUtilsFacadeFactory.getLocalInstance(ctx);
                    //backTask(url,requestId,صosf,Զ,)
                    //isyUtilsFacade.backTask(isyUtilsFacade.getConfig().get("ip") + "/gateway/iit/reverseCalculateTax/getASynIndividualIncomeTaxFeedback", requestId, "synIndividualIncomeTaxService", jsonObject.toString(), TaskCatalogEnum.CAL_GET);
                    JSONObject json = new JSONObject();
                    json.put("requestId", requestId);
                    //json.put("param", jsonObject.toString());
                    isyUtilsFacade.addTask("synIncomeTaxDeclareService", json.toJSONString(), TaskCatalogEnum.TAX, "");
                }
            }
            JSONUtils.writeJson(response, mapper.writeValueAsString(apiResponse));
            logger.error("taxDeclareAction-----end-------");

        } catch (IOException e) {
            throw new RuntimeException(e);
        } catch (EASBizException e) {
            throw new RuntimeException(e);
        } catch (SQLException e) {
            throw new RuntimeException(e);
        }
    }
    ///**
    // * ˰걨
    // *
    // * @param request
    // * @param response
    // * @param modelMap
    // */
    //@Override
    //public void taxDeclareAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap) throws BOSException, SHRWebException {
    //    super.taxDeclareAction(request, response, modelMap);
    //    logger.error("taxDeclareAction-----start-------");
    //
    //    Context ctx = SHRContext.getInstance().getContext();
    //    //˰걨
    //    String selectedId = request.getParameter("selectedId");
    //    String sqlInString = CmpUtils.spiltToSqlString(selectedId);
    //    if (StringUtils.isEmpty(sqlInString)) {
    //        sqlInString = "''";
    //    }
    //    try {
    //        String oqlBuffer = "select id,yearMonth,totalPerson,totalMoney,taxRebate,declareStatus,versionCode,yearMonthDate,tbType,taxUnit.id,taxUnit.name,taxUnit.taxNumber,taxUnit.regNumber,taxUnit.areaCode,taxUnit.declPassword, batchNo where id in ( " + sqlInString + " )";
    //        IncomeTaxDeclarCollection declareCollection = IncomeTaxDeclarFactory.getLocalInstance(ctx).getIncomeTaxDeclarCollection(oqlBuffer);
    //        Map<String, List<Map<String, Object>>> declareDataMap = null;
    //        if (declareCollection.size() == 0) {
    //            declareCollection.add(new IncomeTaxDeclarInfo());
    //        }
    //        for (int i = 0; i < declareCollection.size(); i++) {
    //            IncomeTaxDeclarInfo incomeTaxDeclarInfo = declareCollection.get(i);
    //            //˰λ
    //            //TaxUnitInfo taxUnitInfo = incomeTaxDeclarInfo.getTaxUnit();
    //            TaxUnitInfo taxUnitInfo = TaxUnitFactory.getLocalInstance(ctx).getTaxUnitInfo(new ObjectUuidPK("FqEAAACXVqyPHZiq"));
    //            //
    //            //String yearMonth = incomeTaxDeclarInfo.getYearMonth();
    //            //
    //            ClientProxyFactory clientProxyFactory = ClientProxyFactoryUtils.getClientProxyFactory();
    //            //˰ӿ
    //            DeclarationRequest declarationRequest = clientProxyFactory.getDeclarationRequest();
    //            //ȡ
    //            //ȡ
    //            CompanyDeclareRequest declareRequestParameter = getDeclareRequestParameter(taxUnitInfo, declareDataMap, "202408");
    //            //걨ݱ
    //            ApiResponse<AsyncResult> apiResponse = declarationRequest.send(declareRequestParameter);
    //            logger.error("asyncResultApiResponse-----getCode-------" + apiResponse.getHead().getCode());
    //            logger.error("asyncResultApiResponse-----getMsg--------" + apiResponse.getHead().getMsg());
    //            if (apiResponse.getHead().getCode().equals("00000000")) {
    //                AsyncResult body = apiResponse.getBody();
    //                String requestId = body.getRequestId();
    //                logger.error("requestId-----" + requestId);
    //                //ѯ㷴
    //                ISYUtilsFacade isyUtilsFacade = SYUtilsFacadeFactory.getLocalInstance(ctx);
    //                //backTask(url,requestId,صosf,Զ,)
    //                //isyUtilsFacade.backTask(isyUtilsFacade.getConfig().get("ip") + "/gateway/iit/reverseCalculateTax/getASynIndividualIncomeTaxFeedback", requestId, "synIndividualIncomeTaxService", jsonObject.toString(), TaskCatalogEnum.CAL_GET);
    //                JSONObject json = new JSONObject();
    //                json.put("requestId", requestId);
    //                //json.put("param", jsonObject.toString());
    //                isyUtilsFacade.addTask("synIncomeTaxDeclareService", json.toJSONString(), TaskCatalogEnum.TAX, "");
    //            }
    //        }
    //        logger.error("taxDeclareAction-----end-------");
    //
    //    } catch (IOException e) {
    //        throw new RuntimeException(e);
    //    } catch (EASBizException e) {
    //        throw new RuntimeException(e);
    //    }
    //}

    /**
     * ȡ
     * ע:
     * 1.ͶͬһԲȫһԽãܵ걨Ҫͬнһ걨
     * 2.ͶͬһԲ𡢸ã˰ҪͶͬһԲ𡢸ñд˰
     *
     * @param taxUnitInfo
     * @param declareDataMap
     * @param yearMonth
     * @return
     */
    private CompanyDeclareRequest getDeclareRequestParameter(TaxUnitInfo taxUnitInfo,
                                                             Map<String, List<Map<String, Object>>> declareDataMap,
                                                             String yearMonth) throws BOSException, SQLException, EASBizException {
        CompanyDeclareRequest declareRequestPara = new CompanyDeclareRequest();
        //id
        String bizNo = UUID.randomUUID().toString();
        logger.error("bizNo:" + bizNo);
        //ⲿҵ񶩵*
        declareRequestPara.setBizNo(bizNo);
        //ҵ*
        declareRequestPara.setName(taxUnitInfo.getName());
        //˰*
        declareRequestPara.setTaxNo(taxUnitInfo.getTaxNumber());
        //*
        declareRequestPara.setArea(taxUnitInfo.getAreaCode());
        //Ǽ
        declareRequestPara.setRegistrationNumber(taxUnitInfo.getRegNumber());
        //ű
        //declareRequestPara.setDeptNo("");
        //
        //declareRequestPara.setDeptName("");
        //˰YYYYMM*
        declareRequestPara.setMonth(yearMonth);
        //ʵ˺
        //declareRequestPara.setRealNameAccount();
        //ʵ
        //declareRequestPara.setRealNamePassword();
        //ʵ
        //declareRequestPara.setEncryptedRealNamePassword();
        //걨
        //declareRequestPara.setDeclarePassword("Aa123456");
        String declPassword = taxUnitInfo.getDeclPassword();
        if (StringUtils.isEmpty(declPassword)) {
            throw new BOSException("걨벻Ϊ!");
        }
        declareRequestPara.setDeclarePassword(Base64Utils.decode(declPassword));
        //걨
        //taxRequestPara.setEncryptedDeclarePassword();
        //*
        declareRequestPara.setPasswordType("0");
        //ְڴ 11ְԶգԱ״̬ɡΪʱְֶԶգĬ߼
        //22ְڲԶգԱ״̬ɡΪʱְڲԶգͻְֶδַ
        //declareRequestPara.setResignDateStrategy();
        //ҵԱб
        List<DetailCompanyEmployee> companyEmployeeList = getCompanyEmployeeList();
        declareRequestPara.setCompanyEmployeeList(companyEmployeeList);
        //ۺ
        //ۺö
        ComplexIncomeRequest complexIncomeRequest = new ComplexIncomeRequest();
        //˰˴
        //complexIncomeRequest.setTaxCount();
        //Ӧ۽˰
        //complexIncomeRequest.setRefundTax();
        //ⷽʽ
        //complexIncomeRequest.setDeductionMode();
        //
        //complexIncomeRequest.setRatio();
        //޶
        //complexIncomeRequest.setLimitAmount();
        ////н
        //NormalSalarySpecIncome normalSalarySpecIncome = getNormalSalarySpecIncome(declareDataMap);
        //complexIncomeRequest.setNormalSalarySpecIncome(normalSalarySpecIncome);
        //ȫһԽб
        //List<ComplexIncome> annualOneTimeBonusIncomeList = getAnnualOneTimeBonusIncomeList(declareDataMap);
        //List<ComplexIncome> annualOneTimeBonusIncomeList = new ArrayList();
        //ComplexIncome annualOneTimeBonusIncome = getAnnualOneTimeBonusIncome();
        //annualOneTimeBonusIncomeList.add(annualOneTimeBonusIncome);
        //complexIncomeRequest.setAnnualOneTimeBonusIncome(annualOneTimeBonusIncomeList);
        //һ񱨳б
        //List<ComplexIncome> laborRemunerationIncome = getLaborRemunerationIncome(declareDataMap);
        ////ͶͬһԲб
        //List<ComplexIncome> compensateIncome = getCompensateIncome(declareDataMap);
        //complexIncomeRequest.setCompensateIncome(compensateIncome);
        // н
        NormalSalarySpecIncome normalSalarySpecIncome = getNormalSalarySpecIncomes();
        complexIncomeRequest.setNormalSalarySpecIncome(normalSalarySpecIncome);
        // ȫһԽ
        List<ComplexIncome> annualOneTimeBonusIncome = getAnnualOneTimeBonusIncomes();
        complexIncomeRequest.setAnnualOneTimeBonusIncome(annualOneTimeBonusIncome);
        //// һ񱨳б
        //List<ComplexIncome> laborRemunerationIncome = getLaborRemunerationIncomes();
        //complexIncomeRequest.setLaborRemunerationIncome(laborRemunerationIncome);

        declareRequestPara.setComplexIncomeRequest(complexIncomeRequest);
        return declareRequestPara;
    }

    /**
     * ȡһ񱨳
     * taxItemPlanName  ˰Ŀ
     * cmpschemeid ID
     *
     * @return
     */
    public List<ComplexIncome> getLaborRemunerationIncomes() {
        List<ComplexIncome> complexIncomeList = new ArrayList();
        ComplexIncome complexIncome = new ComplexIncome();
        //
        complexIncome.setName(personName);
        //֤
        complexIncome.setLicenseType(cardType);
        complexIncome.setLicenseNumber(cardNumber);
        //˰
        complexIncome.setAbroadIncome(new BigDecimal("123123"));
        //
        complexIncome.setIncome(new BigDecimal("10000"));
        //Ŀ
        complexIncome.setIncomeItemName("һ񱨳");
        complexIncomeList.add(complexIncome);
        return complexIncomeList;
    }

    /**
     * ȡȫһԽ
     * taxItemPlanName  ˰Ŀ
     * cmpschemeid ID
     *
     * @return
     */
    public List<ComplexIncome> getAnnualOneTimeBonusIncomes() {
        List<ComplexIncome> complexIncomeList = new ArrayList();
        ComplexIncome complexIncome = new ComplexIncome();
        //
        complexIncome.setName(personName);
        //֤
        complexIncome.setLicenseType(cardType);
        complexIncome.setLicenseNumber(cardNumber);
        //˰
        complexIncome.setAbroadIncome(new BigDecimal("123123"));
        //
        complexIncome.setIncome(new BigDecimal("10000"));
        //Ŀ
        complexIncome.setIncomeItemName("ȫһԽ");
        complexIncomeList.add(complexIncome);
        return complexIncomeList;
    }

    /**
     * ҵԱб*
     *
     * @return
     */
    private List<DetailCompanyEmployee> getCompanyEmployeeList() {
        List<DetailCompanyEmployee> companyEmployeeList = new ArrayList<DetailCompanyEmployee>();
        //ȡԱ
        DetailCompanyEmployee detailCompanyEmployee = getDetailCompanyEmployee();
        companyEmployeeList.add(detailCompanyEmployee);
        return companyEmployeeList;
    }

    /**
     * ͶͬһԲб
     *
     * @param caluDataMap
     * @return
     */
    private List<ComplexIncome> getCompensateIncome(
            Map<String, List<Map<String, Object>>> caluDataMap) {
        List<ComplexIncome> compensateIncome = new ArrayList<ComplexIncome>();
        List<Map<String, Object>> list = caluDataMap.get("jcldhtlb");
        for (int i = 0; list != null && i < list.size(); i++) {
            //˰Ӧ+˰ϸ
            Map<String, Object> map = list.get(i);
            ComplexIncome complexIncome = new ComplexIncome();
            //*
            complexIncome.setName((String) map.get("personName"));
            //֤*
            complexIncome.setLicenseType((String) map.get("cardType"));
            //֤*
            complexIncome.setLicenseNumber((String) map.get("cardNumber"));
            //todo ǷԶ˰
            complexIncome.setIsAutoGenerateExempt("");
            //*
            complexIncome.setIncome((BigDecimal) map.get("t39"));
            //˰
            complexIncome.setExemptIncome((BigDecimal) map.get("t2"));
            //
            //complexIncome.setOther(BigDecimal.ZERO);
            //˰      
            complexIncome.setTaxDeduction((BigDecimal) map.get("t17"));
            //ע
            //complexIncome.setRemark("");
            //Ŀ*
            complexIncome.setIncomeItemName("ͶͬһԲ");
            //׼۳ľ      
            complexIncome.setDeductibleDonation((BigDecimal) map.get("t16"));
            compensateIncome.add(complexIncome);
        }
        return compensateIncome;
    }

    /**
     * һ񱨳б
     *
     * @param caluDataMap
     * @return
     */
    private List<ComplexIncome> getLaborRemunerationIncome(Map<String, List<Map<String, Object>>> caluDataMap) {
        List<ComplexIncome> laborRemunerationIncome = new ArrayList<>();
        List<Map<String, Object>> list = caluDataMap.get("lwbclb");
        for (int i = 0; list != null && i < list.size(); i++) {
            Map<String, Object> map = list.get(i);
            ComplexIncome complexIncome = new ComplexIncome();
            //*
            complexIncome.setName((String) map.get("personName"));
            //֤*
            complexIncome.setLicenseType((String) map.get("cardType"));
            //֤*
            complexIncome.setLicenseNumber((String) map.get("cardNumber"));
            //Ƿϸ걨
            //complexIncome.setIsDetailedDeclaration("");
            //*
            complexIncome.setIncome((BigDecimal) map.get("t1"));
            //˰
            complexIncome.setExemptIncome((BigDecimal) map.get("t2"));
            //ҵ
            complexIncome.setCommercialHealthInsurance((BigDecimal) map.get("t13"));
            //˰ϱ
            complexIncome.setExtensionEndowmentInsurance((BigDecimal) map.get("t14"));
            //
            //complexIncome.setOther(BigDecimal.ZERO);
            //˰
            complexIncome.setTaxDeduction((BigDecimal) map.get("t17"));
            //ע
            //complexIncome.setRemark("");
            //
            // complexIncome.setDeductionAmount(BigDecimal.ZERO);
            //Ӧ˰
            //complexIncome.setPayableAmount(BigDecimal.ZERO);
            //˰
            //complexIncome.setTaxRate(BigDecimal.ZERO);
            //Ŀ*
            complexIncome.setIncomeItemName("һ񱨳");
            //۳˰
            complexIncome.setTaxDeductible((BigDecimal) map.get("t18"));
            laborRemunerationIncome.add(complexIncome);
        }
        return laborRemunerationIncome;
    }

    /**
     * ȡȫһԽ
     * taxItemPlanName  ˰Ŀ
     * cmpschemeid ID
     *
     * @return
     */
    public ComplexIncome getAnnualOneTimeBonusIncome() throws SQLException, BOSException {
        ComplexIncome complexIncome = new ComplexIncome();
        //
        complexIncome.setName(personName);
        //֤
        complexIncome.setLicenseType(cardType);
        complexIncome.setLicenseNumber(cardNumber);
        //˰
        complexIncome.setAbroadIncome(new BigDecimal("123123"));
        //
        complexIncome.setIncome(new BigDecimal("10000"));
        return complexIncome;
    }

    /**
     * ȫһԽб
     *
     * @return
     */
    private List<ComplexIncome> getAnnualOneTimeBonusIncomeList(
            Map<String, List<Map<String, Object>>> caluDataMap) {
        List<ComplexIncome> annualOneTimeBonusIncome = new ArrayList<>();
        List<Map<String, Object>> list = caluDataMap.get("qnycxjjsslb");
        for (int i = 0; list != null && i < list.size(); i++) {
            Map<String, Object> map = list.get(i);
            ComplexIncome complexIncome = new ComplexIncome();
            //*
            complexIncome.setName((String) map.get("personName"));
            //֤*
            complexIncome.setLicenseType((String) map.get("cardType"));
            //֤*
            complexIncome.setLicenseNumber((String) map.get("cardNumber"));
            //*
            complexIncome.setIncome((BigDecimal) map.get("t1"));
            //˰
            complexIncome.setExemptIncome((BigDecimal) map.get("t2"));
            //
            //complexIncome.setOther(BigDecimal.ZERO);
            //˰
            complexIncome.setTaxDeduction((BigDecimal) map.get("t17"));
            //ע
            //complexIncome.setRemark("");
            //Ŀ*
            complexIncome.setIncomeItemName("ȫһԽ");
            //׼۳ľ
            complexIncome.setDeductibleDonation((BigDecimal) map.get("t16"));
            annualOneTimeBonusIncome.add(complexIncome);
        }
        return annualOneTimeBonusIncome;
    }

    /**
     * ȡн
     *
     * @return
     */
    public NormalSalarySpecIncome getNormalSalarySpecIncomes() throws BOSException, EASBizException {
        //н
        NormalSalarySpecIncome normalSalarySpecIncome = new NormalSalarySpecIncome();
        //нб
        List<ComplexIncome> normalSalarySpec = new ArrayList();
        ComplexIncome complexIncome = new ComplexIncome();
        //
        complexIncome.setName(personName);
        //֤
        complexIncome.setLicenseType(cardType);
        complexIncome.setLicenseNumber(cardNumber);
        //˰
        complexIncome.setAbroadIncome(new BigDecimal("10000"));
        //
        complexIncome.setIncome(new BigDecimal("10000"));
        //Ŀ
        complexIncome.setIncomeItemName("н");
        normalSalarySpecIncome.setNormalSalarySpec(normalSalarySpec);
        return normalSalarySpecIncome;
    }

    /**
     * Ա
     *
     * @return
     */
    public DetailCompanyEmployee getDetailCompanyEmployee() {

        //Ա
        DetailCompanyEmployee detailCompanyEmployee = new DetailCompanyEmployee();
        //
        detailCompanyEmployee.setName(personName);
        //֤
        detailCompanyEmployee.setLicenseType(cardType);
        //֤պ
        detailCompanyEmployee.setLicenseNumber(cardNumber);
        //Ա״̬
        //detailCompanyEmployee.setState(personInfo.getEmployeeType().getName());
        ////Ա˰Ϣ->ְܹʹҵϢ
        //ITaxPersonRecordEntry iTaxPersonRecordEntry = TaxPersonRecordEntryFactory.getLocalInstance(ctx);
        //TaxPersonRecordEntryCollection taxPersonRecordEntryCollection = iTaxPersonRecordEntry.getTaxPersonRecordEntryCollection("where person.id = '" + personInfo.getId() + "'");
        //TaxPersonRecordEntryInfo taxPersonRecordEntryInfo = taxPersonRecordEntryCollection.get(0);
        //ְܹ  ѡԱӪԱ֤ȯˡʵϰѧȫѧ
        detailCompanyEmployee.setIsEmployee("Ա");
        //ֻ
        detailCompanyEmployee.setPhone("13333282630");
        //detailCompanyEmployee.setIsEmployee(taxPersonRecordEntryInfo.getEmployedType().getAlias());
        //ܹ  YYYY-MM-DD,ܴڵǰʱ䣬ְܹѡԱӪԱ֤ȯʱ¼
        SimpleDateFormat inputFormat = new SimpleDateFormat("yyyy-MM-dd");
        detailCompanyEmployee.setEmployedDate("2022-10-02");
        ////Ա
        detailCompanyEmployee.setGender("Ů");
        ////
        detailCompanyEmployee.setBirthday("2001-01-01");
        // nationality
        //NationalityInfo nationality = personInfo.getNationality();
        detailCompanyEmployee.setNationality("й");
        return detailCompanyEmployee;
    }

    /**
     * ȡн
     *
     * @return
     */
    private NormalSalarySpecIncome getNormalSalarySpecIncome
    (Map<String, List<Map<String, Object>>> caluDataMap) {
        //н
        NormalSalarySpecIncome normalSalarySpecIncome = new NormalSalarySpecIncome();
        //нǷҪר*
        //normalSalarySpecIncome.setZcgzxjsfxyzx("");
        //нǷۼƣ걨/¼ʱʹã
        //normalSalarySpecIncome.setZcgzxjsfcrlj("");
        //˰ѡ
        normalSalarySpecIncome.setAnnuityAndHouseProvidentFundOption("");
        //Ͻ
        normalSalarySpecIncome.setPersonalPensionOption("");
        //¸Ͻ
        normalSalarySpecIncome.setLastMonthPersonalPensionOption("");
        List<ComplexIncome> normalSalarySpec = new ArrayList<>();
        //н(ר)б*
        normalSalarySpecIncome.setNormalSalarySpec(normalSalarySpec);
        List<Map<String, Object>> list = caluDataMap.get("zcgzxjlb");
        for (int i = 0; list != null && i < list.size(); i++) {
            Map<String, Object> map = list.get(i);
            ComplexIncome complexIncome = new ComplexIncome();
            //*
            complexIncome.setName((String) map.get("personName"));
            //֤*
            complexIncome.setLicenseType((String) map.get("cardType"));
            //֤*
            complexIncome.setLicenseNumber((String) map.get("cardNumber"));
            //Ƿϸ걨
            //complexIncome.setIsDetailedDeclaration("");
            //*
            complexIncome.setIncome((BigDecimal) map.get("t1"));
            //˰
            complexIncome.setExemptIncome((BigDecimal) map.get("t2"));
            //ϱ
            complexIncome.setEndowmentInsurance((BigDecimal) map.get("t3"));
            //ҽƱ
            complexIncome.setMedicalInsurance((BigDecimal) map.get("t4"));
            //ʧҵ
            complexIncome.setUnemploymentInsurance((BigDecimal) map.get("t5"));
            //ס
            complexIncome.setHouseProvidentFund((BigDecimal) map.get("t6"));
            //Ů֧
            complexIncome.setChildEducationExpenditure((BigDecimal) map.get("t64"));
            //֧
            complexIncome.setSupportElderExpenditure((BigDecimal) map.get("t65"));
            //ס֧
            complexIncome.setHouseRentExpenditure((BigDecimal) map.get("t67"));
            //ݴ֧
            complexIncome.setHouseLoanExpenditure((BigDecimal) map.get("t66"));
            //֧
            complexIncome.setContinueEducationExpenditure((BigDecimal) map.get("t68"));
            //Ӥ׶ջ֧
            complexIncome.setBabyCareExpenditure((BigDecimal) map.get("t70"));
            //todo ҵ/ְҵ
            complexIncome.setAnnuity(BigDecimal.ZERO);
            //ҵ
            complexIncome.setCommercialHealthInsurance((BigDecimal) map.get("t13"));
            //˰ϱ
            complexIncome.setExtensionEndowmentInsurance((BigDecimal) map.get("t14"));
            //
            complexIncome.setOther(BigDecimal.ZERO);
            //˰
            complexIncome.setTaxDeduction(BigDecimal.ZERO);
            //ע Ҫдһڱעд۳Ŀ
            complexIncome.setRemark("");
            //Ӧ˰
            complexIncome.setPayableAmount(BigDecimal.ZERO);
            //ѽ˰
            complexIncome.setPaidAmount(BigDecimal.ZERO);
            //˰
            complexIncome.setTaxRate(BigDecimal.ZERO);
            //Ŀ
            complexIncome.setIncomeItemName("н");
            //ۼ ۼ=еĹн֮+ڹн֮ͣ˰㣩
            complexIncome.setAccumulatedIncome(BigDecimal.ZERO);
            //ۼר۳
            complexIncome.setAccumulatedSpecDeduction(BigDecimal.ZERO);
            //ۼ۳
            complexIncome.setAccumulatedOtherDeduction(BigDecimal.ZERO);
            //ۼƼö
            complexIncome.setAccumulatedDeductionAmount(BigDecimal.ZERO);
            //ۼŮ֧
            complexIncome.setAccumulatedChildEducation(BigDecimal.ZERO);
            //ۼƼ֧
            complexIncome.setAccumulatedContinueEducation(BigDecimal.ZERO);
            //ۼס֧
            complexIncome.setAccumulatedHouseRent(BigDecimal.ZERO);
            //ۼƷݴ֧
            complexIncome.setAccumulatedHouseLoan(BigDecimal.ZERO);
            //ۼ֧
            complexIncome.setAccumulatedSupportElder(BigDecimal.ZERO);
            //ۼ3Ӥ׶ջ֧
            complexIncome.setAccumulatedBabyCare(BigDecimal.ZERO);
            //ۼ׼۳ľ
            complexIncome.setAccumulatedDeductibleDonation(BigDecimal.ZERO);
            //ۼƸϽ
            complexIncome.setAccumulatedPersonalPension(BigDecimal.ZERO);
            //ۼƸϽУ
            complexIncome.setAccumulatedPersonalPensionCheckCode("");
            //׼۳ľ
            complexIncome.setDeductibleDonation(BigDecimal.ZERO);
            //ùʽ
            complexIncome.setFormula("");
            //ڹ
            complexIncome.setDomesticWorkingDays(BigDecimal.ZERO);
            //⹤
            complexIncome.setAbroadWorkingDays(BigDecimal.ZERO);
            //֧
            complexIncome.setAbroadIncome(BigDecimal.ZERO);
            //֧
            complexIncome.setDomesticIncome(BigDecimal.ZERO);
            normalSalarySpec.add(complexIncome);
        }
        return normalSalarySpecIncome;
    }

    /**
     * ȡҵԱб
     */
    private List<DetailCompanyEmployee> getCompanyEmployeeList(Map<String, List<Map<String, Object>>> caluDataMap) {
        List<DetailCompanyEmployee> companyEmployeeList = new ArrayList<>();
        List<Map<String, Object>> list = caluDataMap.get("zcgzxjlb");
        for (int i = 0; list != null && i < list.size(); i++) {
            Map<String, Object> map = list.get(i);
            DetailCompanyEmployee employee = new DetailCompanyEmployee();
            //*
            employee.setName((String) map.get("personName"));
            //֤*
            employee.setLicenseType((String) map.get("cardType"));
            //֤*
            employee.setLicenseNumber((String) map.get("cardNumber"));
            //ű
            //employee.setDeptNo("");
            //
            employee.setEmployeeNumber((String) map.get("personNumber"));
            //
            //employee.setPeriod("");
            //ֻ  йй״뾳ʱ䳬һ±
            employee.setPhone((String) map.get("phoneNumber"));
            //Ա״̬* ĬΪѡ/
            employee.setState((String) map.get("personstatusName"));
            //ǷԱ* ѡԱӪԱ֤ȯˡʵϰѧȫѧ
            employee.setIsEmployee((String) map.get("employedtypeName"));
            //ְȾҵ  ԱӪԱ֤ȯʱѡ񣺵״ְѧ״ְԱдĬΪ
            employee.setFirstEmploymentSituation((String) map.get("situationName"));
            //ܹ
            employee.setEmployedDate((String) map.get("employeddate"));
            //Ա*   /Ů
            employee.setGender((String) map.get("gender"));
            //* YYYY-MM-DD Ҫ֤ϱһ
            employee.setBirthday((String) map.get("birthday"));
            //*
            employee.setNationality((String) map.get("nationalityName"));
            //Ա* /
            employee.setArea((String) map.get("isoversea"));
            //ְ
            employee.setResignDate((String) map.get("departuredate"));
            //Ͷܶ
            employee.setPersonInvestment((BigDecimal) map.get("investmenttotal"));
            //Ͷʱ
            employee.setPersonInvestmentRatio((BigDecimal) map.get("investmentrate"));
            //Ƿм
            String isdisability = (String) map.get("isdisability");
            employee.setIsDisabled(isdisability);
            if ("".equals(isdisability)) {
                //todo м֤
                employee.setDisableCardTypeName("м֤");
            }
            //Ƿ
            employee.setIsMartyr((String) map.get("ishero"));
            //Ƿ
            employee.setIsBereavedGaffer((String) map.get("isold"));
            //м֤
            employee.setDisableCardNumber((String) map.get("discardnumber"));
            //֤
            employee.setMartyrCardNumber((String) map.get("herocardnumber"));
            //
            employee.setEmail((String) map.get("email"));
            //ѧ
            employee.setEducation((String) map.get("diploma"));
            //ְ
            employee.setPosition((String) map.get("positionName"));
            //ʡ()
            employee.setDepositBankProvinceName((String) map.get("bankcardprovince"));
            //
            employee.setDepositBank((String) map.get("bankcardprovince"));
            //˺
            employee.setBankAccount((String) map.get("account"));
            //סʡ
            employee.setResidentProvince((String) map.get("address"));
            //ס
            employee.setResidentCity((String) map.get("addresscity"));
            //ס
            employee.setResidentDistrict((String) map.get("addresscounty"));
            //סֵ
            employee.setResidentStreet((String) map.get("addressstreet"));
            //ʡ
            employee.setCensusProvince((String) map.get("hometown"));
            //
            employee.setCensusCity((String) map.get("hometowncity"));
            //
            employee.setCensusDistrict((String) map.get("hometowncountry"));
            //ֵ
            employee.setCensusStreet((String) map.get("hometownstreet"));
            //ϸַ
            employee.setCensusAddress((String) map.get("hometowndetailed"));
            //ע
            employee.setEmpRemark((String) map.get("desc"));
            //
            employee.setBirthplace((String) map.get("birthplaceName"));
            //״뾳ʱ
            employee.setFirstEntryDate((String) map.get("entrydate"));
            //Ԥ뾳ʱ
            employee.setEstimatedDepartureDate((String) map.get("leavedate"));
            //ϵʡ
            employee.setContactProvince((String) map.get("contactaddress"));
            //ϵس
            employee.setContactCity((String) map.get("contactcity"));
            //ϵ
            employee.setContactDistrict((String) map.get("contactcountry"));
            //ϵؽֵ
            employee.setContactStreet((String) map.get("contactstreet"));
            //ϵϸַ
            employee.setContactStreet((String) map.get("contactdetailed"));
            //
            employee.setChineseName((String) map.get("chinesename"));
            //˰
            employee.setTaxRelatedReason((String) map.get("taxreason"));
            //֤
            employee.setOtherLicenseNumber((String) map.get("othercardnumber"));
            //֤    ֤Ϊþ֤þ֤գл񹲺͹˹֤Aࣩл񹲺͹˹֤Bࣩл񹲺͹˹֤Cࣩ,л񹲺͹۰ľס֤,л񹲺͹̨ס֤йգ۰ľڵ̨֤ͨ½֤֤ͨ
            employee.setOtherLicenseType((String) map.get("othercardtype"));
            //Ƿ۳ãԭǷλ
            employee.setIsMainUnits((String) map.get("deductfees"));
            companyEmployeeList.add(employee);
        }
        return companyEmployeeList;
    }
}
