package com.kingdee.eas.custom.compensation.service;

import cn.com.servyou.dto.ApiResponse;
import cn.com.servyou.dto.declare.Feedback;
import cn.com.servyou.rmi.client.ClientProxyFactory;
import cn.com.servyou.service.DeclarationRequest;
import com.alibaba.fastjson.JSONObject;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.bsf.service.app.IHRMsfService;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.custom.shuiyou.interfacelog.LogInfoFactory;
import com.kingdee.eas.custom.shuiyou.interfacelog.LogInfoInfo;
import com.kingdee.eas.custom.shuiyou.task.MessageResult;
import com.kingdee.eas.custom.shuiyou.utils.ClientProxyFactoryUtils;
import org.apache.log4j.Logger;

import java.io.IOException;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

/**
 * @author qingwu
 * @date 2024/9/19
 * @apiNote
 */
public class SynIncomeTaxDeclareService implements IHRMsfService {
    Logger logger = Logger.getLogger("com.kingdee.eas.custom.compensation.service.SynIncomeTaxDeclareService");

    public Object process(Context context, Map map) throws EASBizException, BOSException {
        //ӿ־ʵ
        LogInfoInfo logInfo = new LogInfoInfo();
        //
        logInfo.setEntrance(this.getClass().getName());
        logInfo.setBizDate(new Date());
        Map resMap = new HashMap();
        logger.error("SynIncomeTaxDeclareService----------OSF----Start");
        JSONObject paramData = JSONObject.parseObject((String) map.get("paramData"));
        logger.error("paramData--------" + paramData);
        String requestId = paramData.getString("requestId");
        //JSONObject param = paramData.getJSONObject("param");
        logger.error("requestId--------" + requestId);
        //logger.error("param--------" + param);
        ObjectMapper mapper = new ObjectMapper();
        try {
            //ͻ˴
            ClientProxyFactory clientProxyFactory = ClientProxyFactoryUtils.getClientProxyFactory();
            //˰ӿ
            DeclarationRequest declarationRequest = clientProxyFactory.getDeclarationRequest();
            //걨ݷ  requestIdId   reportType:걨[1:ۺ;2:;3:Ǿ;4:۹]
            ApiResponse<Feedback> feedback = declarationRequest.getFeedback(requestId, "1");
            logInfo.setInterfaceAddress("/gateway/iit/report/getFeedback");//ӿڵַ
            logInfo.setInterfaceName("getFeedback");//ӿ
            logger.error("feedback--------" + mapper.writeValueAsString(feedback));
            String status = feedback.getHead().getStatus();
            Feedback body = null;
            if ("N".equals(status)) {
                //ʧӦ
                String msg = feedback.getHead().getMsg();
                //throw new BOSException(msg);
                return MessageResult.FAILED(msg);
            } else {
                //óɹ
                //id
                body = feedback.getBody();
                logInfo.setOutParameter(mapper.writeValueAsString(body));//ز
                LogInfoFactory.getLocalInstance(context).addnew(logInfo);
            }
            return MessageResult.SUCCESS(mapper.writeValueAsString(body));
        } catch (IOException e) {
            e.printStackTrace();
            logInfo.setErrorInfo(e.getMessage());//Ϣ
            LogInfoFactory.getLocalInstance(context).save(logInfo);
            //throw new BOSException(e);
            return MessageResult.ERROR(e.getMessage());
        }
    }

}
