package com.kingdee.eas.custom.shuiyou.inter.handler;

import com.kingdee.bos.Context;
import com.kingdee.bos.dao.ormapping.ObjectUuidPK;
import com.kingdee.bos.metadata.entity.SelectorItemCollection;
import com.kingdee.bos.metadata.entity.SelectorItemInfo;
import com.kingdee.eas.custom.shuiyou.task.ITask;
import com.kingdee.eas.custom.shuiyou.task.TaskFactory;
import com.kingdee.eas.custom.shuiyou.task.TaskInfo;
import com.kingdee.shr.base.syssetting.context.SHRContext;
import com.kingdee.shr.base.syssetting.exception.SHRWebException;
import com.kingdee.shr.base.syssetting.web.handler.ListHandler;
import org.springframework.ui.ModelMap;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * description: TaskListHandler <br>
 * date: 2024/9/12 10:56 <br>
 * author: lhbj <br>
 * version: 1.0 <br>
 */
public class TaskListHandler extends ListHandler {


    public String enableAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap) throws SHRWebException {
        String billId = this.getBillId(request);
        Context ctx = SHRContext.getInstance().getContext();
        try {
            ITask iTask = TaskFactory.getLocalInstance(ctx);
            SelectorItemCollection sc = new SelectorItemCollection();
            sc.add(new SelectorItemInfo("id"));
            sc.add(new SelectorItemInfo("url"));
            sc.add(new SelectorItemInfo("requestId"));
            sc.add(new SelectorItemInfo("requestType"));
            sc.add(new SelectorItemInfo("requestParam.id"));
            sc.add(new SelectorItemInfo("requestParam.paramContent"));
            sc.add(new SelectorItemInfo("requestResult.id"));
            sc.add(new SelectorItemInfo("requestResult.resultContent"));
            sc.add(new SelectorItemInfo("requestState"));
            sc.add(new SelectorItemInfo("state"));
            sc.add(new SelectorItemInfo("name"));
            sc.add(new SelectorItemInfo("osfServiceName"));
            sc.add(new SelectorItemInfo("number"));
            sc.add(new SelectorItemInfo("taskPre.id"));
            sc.add(new SelectorItemInfo("taskPre.state"));
            sc.add(new SelectorItemInfo("taskPre.requestState"));
            String[] ids = billId.split(",");
            for(String id : ids) {
                //ָidִ
                TaskInfo taskInfo = iTask.getTaskInfo(new ObjectUuidPK(id), sc);
                taskInfo.setContext(ctx).execute();
            }
        }catch (Exception e){
            e.printStackTrace();
        }
        this.writeSuccessData(billId);
        return null;
    }
}
